#ifndef _LOGGING_H_
#define _LOGGING_H_

#include <windows.h>

#ifdef __cplusplus
extern "C"{
#endif 

#ifdef LOGAPI_EXPORTS
#define LOGAPIBASE        __declspec( dllexport )
#else
#define LOGAPIBASE        __declspec( dllimport )
#endif 

#ifndef LOGAPI
#define LOGAPI            __stdcall
#endif 

#define LOGTYPE_CONSOLE   1L
#define LOGTYPE_FILE      2L
#define LOGTYPE_EVENTLOG  3L


LOGAPIBASE
__out
HANDLE
LOGAPI
LogAttachA
	( __in DWORD   dwLogType
	, __in BOOL    bTimestamp
	, __in BOOL    bEnableLabel
	, __in BOOL    bOverwrite
	, __in LPCSTR  lpName
    );

LOGAPIBASE
__out
HANDLE
LOGAPI
LogAttachW
	( __in DWORD   dwLogType
	, __in BOOL    bTimestamp
	, __in BOOL    bEnableLabel
	, __in BOOL    bOverwrite
	, __in LPCWSTR lpName
    );

#ifdef UNICODE
#define LogAttach LogAttachW
#else
#define LogAttach LogAttachA
#endif // !UNICODE

LOGAPIBASE
__out
BOOL
LOGAPI
LogMessageA
	( __in HANDLE  hLogger
	, __in LPCSTR  lpMessage
    );

LOGAPIBASE
__out
BOOL
LOGAPI
LogMessageW
	( __in HANDLE  hLogger
	, __in LPCWSTR lpMessage
    );

#ifdef UNICODE
#define LogMessage LogMessageW
#else
#define LogMessage LogMessageA
#endif // !UNICODE

LOGAPIBASE
__out
BOOL
LOGAPI
LogWarningA
	( __in HANDLE  hLogger
	, __in LPCSTR  lpWarning
    );

LOGAPIBASE
__out
BOOL
LOGAPI
LogWarningW
	( __in HANDLE  hLogger
	, __in LPCWSTR lpWarning
    );

#ifdef UNICODE
#define LogWarning LogWarningW
#else
#define LogWarning LogWarningA
#endif // !UNICODE

LOGAPIBASE
__out
BOOL
LOGAPI
LogErrorA
	( __in HANDLE  hLogger
	, __in LPCSTR  lpError
    );

LOGAPIBASE
__out
BOOL
LOGAPI
LogErrorW
	( __in HANDLE  hLogger
	, __in LPCWSTR lpError
    );

#ifdef UNICODE
#define LogError LogErrorW
#else
#define LogError LogErrorA
#endif // !UNICODE

LOGAPIBASE
__out
BOOL
LOGAPI
LogDump
	( __in HANDLE  hLogger
	, __in LPVOID  lpBuffer
	, __in DWORD   dwBuffer
	, __in BOOL    bAbsolute
    );

LOGAPIBASE
__out
BOOL
LOGAPI
LogResize
	( __in HANDLE  hLogger
	, __in DWORD   dwLength
	, __in DWORD   dwWidth
    );

LOGAPIBASE
__out
BOOL
LOGAPI
LogColors
	( __in HANDLE  hLogger
	, __in BOOL    bEnable
    );

LOGAPIBASE
VOID
LOGAPI
LogDetach
	( __in HANDLE hLogger
    );

#ifdef __cplusplus
}
#endif

#endif // _LOGGING_H_

// EOF